//+---------------------------------------------------------------------+
//|                                                      Thunder4WD.mq4 |
//|                             ver. 2b EURGBP by rahman_DGBeta (_rdb_) |
//| mod T01 by taltek 090130     |
//|         LibOrderReliable Matthew Kennel & Derk Wehler|
//+---------------------------------------------------------------------+


#property copyright "rahman_DGBeta (_rdb_)"
#property link      "abdulrahman_maros@yahoo.com"

#include <stdlib.mqh>
#include <stderror.mqh> 

extern string ExpertName = "Exp27_T01_maximode_3";
extern string myOrderComment = "maxi";
extern int HourStartSession = 22;
extern int HourStopSession = 4;
extern bool Thunder_1 = TRUE;
extern bool Thunder_2 = TRUE;
extern bool Thunder_3 = TRUE;
extern bool CloseAll_NOW = FALSE;
extern bool StopAfterLastTrade = FALSE;
extern double TargetEquity = 0.0;
extern bool LotsOptimized = TRUE;
extern bool Auto_LotsDecimal = TRUE;
extern int LotsDecimal = 0;
extern double Lots = 0.1;
extern double MaxLots = 0.0;
extern int Risk = 50;
extern int MaxTrades = 5;
extern int MinuteforNextOP = 1;
extern int MinuteForClose = 1;
extern bool Hidden_TP = TRUE;
extern bool Hidden_SL = TRUE;
extern bool Hide_ALL = FALSE;
extern bool AutoRange_SL = TRUE;
extern double StopLoss = 28.0;
extern double SL_OutSession = 32.0;
extern bool AutoRange_TP = TRUE;
extern bool AccountProfitClose = TRUE;
extern double TakeProfit = 6.0;
extern double TakeProfit_FAKE = 25.0;
extern double Slippage = 3.0;
extern double MaxSpread = 3.5;
extern bool AutoPriceFromLast = TRUE;
extern double PriceFromLastOP = 3.0;
extern bool AutoPriceFractal = TRUE;
extern double OPFromFractal = 7.0;
extern bool AutoPriceMid = TRUE;
extern double PriceFromMid = 7.0;
extern string IndicatorSet_1 = "___iTrend___";
extern double i_Trend_Level = 0.0017;
extern string IndicatorSet_2 = "___iMA___";
extern int IMA_PERIOD = 11;
extern string IndicatorSet_3 = "___iRSI___";
extern double iRSI_const = 2.0;
extern string IndicatorSet_4 = "___AngleZero___";
extern int MA_AngleZero_const_1 = 14;
extern int MA_AngleZero_const_2 = 1;
extern int MA_AngleZero_const_3 = 0;
extern double MA_AngleZero_const_4 = 0.2;
extern int MA_AngleZero_const_5 = 6;
extern int MA_AngleZero_const_6 = 0;
extern int MA_AngleZero_const_7 = 9;
extern int MA_AngleZero_const_8 = 1;
extern string IndicatorSet_5 = "___Damiani_Filter___";
extern bool Use_Damiani_Filter = TRUE;
extern string IndicatorSet_6 = "___Envelope___";
extern int RangeD_Min = 80;
extern int Per_RangeD_Avg = 3;
extern int Per_RangeD_SL = 3;
extern int Per_RangeD_SL_Out = 4;
extern int Per_RangeD_TP = 20;
extern int Per_RangeD_OP = 40;
extern int Per_RangeD_Fractal = 28;
extern int Per_RangeD_Mid = 30;
extern string Trade_On_Friday = "___Trade_On_Friday___";
extern bool TradeOnFriday = TRUE;
extern bool CloseOnFriday = TRUE;
extern int Friday_Days = 5;
extern string Loss_Protection = "___Time&Loss_Protection___";
extern bool Time_Protection = TRUE;
extern int LimitTime_1 = 60;
extern int LimitTime_2 = 140;
extern int LimitTime_3 = 170;
extern int LimitTime_4 = 200;
extern int LimitTime_5 = 260;
extern double pips_TP_if_more_limit_time_1 = 3.0;
extern double pips_TP_if_more_limit_time_2 = 2.0;
extern double pips_TP_if_more_limit_time_3 = 0.0;
extern double pips_TP_if_more_limit_time_4 = -1.0;
extern double pips_TP_if_more_limit_time_5 = -3.0;
extern double pips_SL_for_emergency_trend = 3.0;


//    -   LibOrderReliable
int retry_attempts 		= 10; 
double sleep_time 		= 4.0;
double sleep_maximum 	= 25.0;  // in seconds

string OrderReliable_Fname = "OrderReliable fname unset";

static int _OR_err 		= 0;
static int ErrorLevel 	= 3;

string OrderReliableVersion = "V1_1_3"; 

//-------------------------------------------------------


int gi_404 = 55;
bool gi_408 = TRUE;
bool gi_412 = TRUE;
bool gi_416 = TRUE;
bool gi_420 = TRUE;
bool gi_424 = TRUE;
bool gi_428 = TRUE;
extern int MagicNumber_1 = 2727271;
extern int MagicNumber_2 = 2727272;
extern int MagicNumber_3 = 2727273;
int g_ticket_444;
int gi_unused_448 = 0;
int gi_unused_452 = 0;
int gi_unused_456 = 0;
int gi_unused_460 = 0;
int gi_unused_464 = 0;
int gi_unused_468 = 0;
int gi_unused_472 = 0;
int gi_unused_476 = 0;
int gi_unused_480 = 0;
int gi_unused_484 = 0;
int gi_unused_488 = 0;
int gi_unused_492 = 0;
int gi_unused_496 = 0;
int gi_unused_500 = 0;
int gi_unused_504 = 0;
double gd_unused_508 = 0.0;
double gd_unused_516 = 0.0;
double gd_unused_524 = 0.0;
double gd_unused_532 = 0.0;
double gd_unused_540 = 0.0;
double gd_unused_548 = 0.0;
double gd_unused_556 = 0.0;
double gd_unused_564 = 0.0;
double gd_unused_572 = 0.0;
double gd_unused_580 = 0.0;
int gi_unused_588 = 0;
double gd_unused_608 = 0.0;
double gd_unused_616 = 0.0;
double gd_unused_624 = 0.0;
double gd_unused_632 = 0.0;
double gd_unused_640 = 0.0;
double gd_unused_648 = 0.0;
int gi_unused_656 = 0;
int gi_unused_660 = 0;
double g_ifractals_664;
double g_ifractals_672;
double gd_unused_680;
double gd_unused_688;
double g_ifractals_696;
double g_ifractals_704;
double gd_unused_712;
double gd_unused_720;
double gd_unused_728 = 0.0;
double gd_unused_736 = 0.0;
double gd_744 = 0.0;
double gd_unused_752 = 0.0;
double gd_760 = 0.0;
double gd_unused_768 = 0.0;
double gd_unused_776 = 0.0;
double gd_784 = 0.0;
double gd_unused_792 = 0.0;
bool gi_unused_800 = FALSE;
bool gi_unused_804 = FALSE;
double gd_unused_808 = 0.0;
double gd_unused_816 = 0.0;
double gd_unused_824 = 0.0;
double gd_unused_832 = 0.0;
double gd_unused_840 = 0.0;
double gd_unused_848 = 0.0;
double gd_unused_856 = 0.0;
double gd_unused_864 = 0.0;
double gd_unused_872 = 0.0;
double gd_unused_880 = 0.0;
double gd_unused_888 = 0.0;
double gd_unused_896 = 0.0;
double gd_unused_904 = 0.0;
double gd_unused_912 = 0.0;
double gd_unused_920 = 0.0;
double gd_unused_928 = 0.0;
int gi_unused_936 = 0;
int gi_unused_940 = 0;
int gi_unused_944 = 0;
int gi_unused_948 = 0;
int gi_unused_952 = 0;
int gi_unused_956 = 0;
int gi_unused_960 = 0;
double gd_unused_964 = 0.0;
double gd_unused_972 = 0.0;
double gd_unused_980 = 0.0;
double gd_unused_988 = 0.0;
double gd_unused_1004 = 0.0;
double gd_unused_1012 = 0.0;
double gd_unused_1020 = 0.0;
double gd_unused_1028 = 0.0;
double gd_unused_1036 = 0.0;
double gd_unused_1044 = 0.0;
double gd_unused_1052 = 0.0;
double gd_unused_1060 = 0.0;
double gd_unused_1068 = 0.0;
double gd_unused_1076 = 0.0;
double gd_unused_1084 = 0.0;
double gd_unused_1092 = 0.0;
double gd_unused_1100 = 0.0;
double gd_unused_1108 = 0.0;
double gd_unused_1116 = 0.0;
double gd_unused_1124 = 0.0;
double gd_unused_1132 = 0.0;
double gd_unused_1140 = 0.0;
double gd_unused_1148 = 0.0;
double gd_unused_1156 = 0.0;
double gd_unused_1164 = 0.0;
double gd_unused_1172 = 0.0;
double gd_unused_1180 = 0.0;
double gd_unused_1188 = 0.0;
double gd_unused_1204 = 0.0;
double gd_unused_1212 = 0.0;
double gd_unused_1220 = 0.0;
double gd_unused_1228 = 0.0;
double gd_unused_1236 = 0.0;
double gd_unused_1244 = 0.0;
double gd_unused_1252 = 0.0;
double gd_unused_1276 = 0.0;
double gd_unused_1284 = 0.0;
int g_ticket_1292 = -1;
int g_pos_1296 = 0;
int g_count_1300 = 0;
int g_count_1304 = 0;
int g_count_1308 = 0;
int g_count_1312 = 0;
int g_count_1316 = 0;
int g_count_1320 = 0;
int g_count_1324 = 0;
int g_count_1328 = 0;
int g_count_1332 = 0;
int g_count_1336 = 0;
int g_count_1340 = 0;
int g_count_1344 = 0;
int gi_unused_1348 = 0;
int gi_unused_1352 = 0;
int gi_unused_1356 = 0;
int gi_unused_1360 = 0;
int gi_1364 = 0;
int gi_1368 = 0;
double gd_1372 = 0.0;
double gd_1380 = 0.0;
double gd_1388 = 0.0;
double gd_1396 = 0.0;
double gd_1404 = 0.0;
double gd_1412 = 0.0;
double gd_1420 = 0.0;
double gd_1428 = 0.0;
double gd_unused_1436 = 0.0;
double gd_unused_1444 = 0.0;
double gd_unused_1452 = 0.0;
double gd_unused_1460 = 0.0;
extern string Need_Donation = "Abdul Rahman";
extern string PayPal = "abdulrahman_maros@yahoo.com";
extern string Bank_Wire = "BCA : 7990026640";
extern string LibertyReserve = "U7067895";

double gd_custom_2201 = 0.0;
int gd_custom_2202 = 0.0;


int init() {
   gd_custom_2201 = SetPoint();
   gd_custom_2202 = SetBroker();
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   double l_irsi_0;
   double l_irsi_8;
   double ld_16;
   double l_icci_24;
   double l_icci_32;
   double l_icci_40;
   double l_icustom_48;

   HideTestIndicators(TRUE);

   if (TotalOpens() < 1 && StopAfterLastTrade == TRUE) {
      Print("StopAfterLastTrade Function is TRUE");
      return (0);
   }
   if (CloseAll_NOW == TRUE) {
      Print("CloseAll_NOW Aktif, Order is CLOSED ");
      CloseAllNow();
      return (0);
   }
   if (!EquityStop()) {
      Print("Account Equity More Than TargetEquity ", TargetEquity);
      CloseAllNow();
      return (0);
   }
   if (IsTradeTime()) {
      Comment("\n        " + ExpertName, 
         "\n\n        T R A D E   S E S S I O N", 
         "\n    *=====================*", 
         "\n        Broker Time            = ", Hour() + " : " + Minute(), 
         "\n        Time Star Trading    = ", HourStartSession, 
         "\n        Time Stop Trading   = ", HourStopSession, 
         "\n    *=====================*", 
         "\n        S P R E A D          = " + DoubleToStr(MarketInfo(Symbol(), MODE_SPREAD), 0) + "  pips", 
         "\n    *=====================*", 
         "\n        L O T S                 =  " + DoubleToStr(GetLotsSessionA(), 2), 
         "\n        B A L A N C E        =  " + DoubleToStr(AccountBalance(), 2), 
         "\n        E Q U I T Y           =  " + DoubleToStr(AccountEquity(), 2), 
         "\n    *=====================*"); 
//         "\n\n      " + ExpertName + "  EA is free and still on developing", 
//         "\n      You can discuss to me how to applying it or to develop this ea", 
//         "\n      To support my creativity please donate for me with all yours heart...", 
//         "\n\n      For further information or to make a donation please contact me on :", 
//         "\n      email / PayPal : abdulrahman_maros@yahoo.com", 
//         "\n      Bank Wire : BCA : 7990026640", 
//     "\n      Liberty Reserve : U7067895 ( Abdul Rahman )");
   } else {
      Comment("\n        " + ExpertName, 
         "\n\n        O u t   O f   S E S S I O N", 
         "\n    *=====================*", 
         "\n        Broker Time            = ", Hour() + " : " + Minute(), 
         "\n        Time Star Trading    = ", HourStartSession, 
         "\n        Time Stop Trading   = ", HourStopSession, 
         "\n    *=====================*", 
         "\n        S P R E A D          = " + DoubleToStr(MarketInfo(Symbol(), MODE_SPREAD), 0) + "  pips", 
         "\n    *=====================*", 
         "\n        L O T S                 =  " + DoubleToStr(GetLotsSessionA(), 2), 
         "\n        B A L A N C E        =  " + DoubleToStr(AccountBalance(), 2), 
         "\n        E Q U I T Y           =  " + DoubleToStr(AccountEquity(), 2), 
         "\n    *=====================*"); 
//         "\n\n      " + ExpertName + "  EA is free and still on developing", 
//         "\n      You can discuss to me how to applying it or to develop this ea", 
//         "\n      To support my creativity please donate for me with all yours heart...", 
//         "\n\n      For further information or to make a donation please contact me on :", 
//         "\n      email / PayPal : abdulrahman_maros@yahoo.com", 
//         "\n      Bank Wire : BCA : 7990026640", 
//      "\n      Liberty Reserve : U7067895 ( Abdul Rahman )");
   }
   g_count_1300 = 0;
   g_count_1304 = 0;
   g_count_1308 = 0;
   gd_1372 = 0;
   gd_1380 = 0;
   g_count_1312 = 0;
   g_count_1316 = 0;
   g_count_1320 = 0;
   gd_1388 = 0;
   gd_1396 = 0;
   g_count_1324 = 0;
   g_count_1328 = 0;
   g_count_1332 = 0;
   gd_1404 = 0;
   gd_1412 = 0;
   g_count_1336 = 0;
   g_count_1340 = 0;
   g_count_1344 = 0;
   gd_1420 = 0;
   gd_1428 = 0;
   gi_unused_1348 = 0;
   gi_unused_1352 = 0;
   gi_unused_1356 = 0;
   gd_unused_1436 = 0;
   gd_unused_1444 = 0;
   gi_unused_1360 = 0;
   gi_1364 = 0;
   gi_1368 = 0;
   gd_unused_1452 = 0;
   gd_unused_1460 = 0;
   for (g_pos_1296 = 0; g_pos_1296 < OrdersTotal(); g_pos_1296++) {
      OrderSelect(g_pos_1296, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_1 || OrderMagicNumber() == MagicNumber_2 || OrderMagicNumber() == MagicNumber_3 && OrderCloseTime() == 0) {
         g_count_1300++;
         if (OrderType() == OP_BUY) {
            g_count_1304++;
            gd_1372 += OrderLots();
         } else {
            if (OrderType() == OP_SELL) {
               g_count_1308++;
               gd_1380 += OrderLots();
            }
         }
      }
   }
   for (g_pos_1296 = 0; g_pos_1296 < OrdersTotal(); g_pos_1296++) {
      OrderSelect(g_pos_1296, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_1 && OrderCloseTime() == 0) {
         g_count_1312++;
         if (OrderType() == OP_BUY) {
            g_count_1316++;
            gd_1388 += OrderLots();
         } else {
            if (OrderType() == OP_SELL) {
               g_count_1320++;
               gd_1396 += OrderLots();
            }
         }
      }
   }
   for (g_pos_1296 = 0; g_pos_1296 < OrdersTotal(); g_pos_1296++) {
      OrderSelect(g_pos_1296, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_2 && OrderCloseTime() == 0) {
         g_count_1324++;
         if (OrderType() == OP_BUY) {
            g_count_1328++;
            gd_1404 += OrderLots();
         } else {
            if (OrderType() == OP_SELL) {
               g_count_1332++;
               gd_1412 += OrderLots();
            }
         }
      }
   }
   for (g_pos_1296 = 0; g_pos_1296 < OrdersTotal(); g_pos_1296++) {
      OrderSelect(g_pos_1296, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_3 && OrderCloseTime() == 0) {
         g_count_1336++;
         if (OrderType() == OP_BUY) {
            g_count_1340++;
            gd_1420 += OrderLots();
         } else {
            if (OrderType() == OP_SELL) {
               g_count_1344++;
               gd_1428 += OrderLots();
            }
         }
      }
   }
   if (Time_Protection == TRUE) {
      for (g_pos_1296 = OrdersTotal()-1; g_pos_1296 >=0 ; g_pos_1296--) {
         OrderSelect(g_pos_1296, SELECT_BY_POS, MODE_TRADES);
         if (OrderType() == OP_BUY && OrderMagicNumber() == MagicNumber_1 || OrderMagicNumber() == MagicNumber_2 || OrderMagicNumber() == MagicNumber_3) {
            if (TimeCurrent() - OrderOpenTime() > 60 * LimitTime_1 && TimeCurrent() - OrderOpenTime() < 60 * LimitTime_2 && OrderProfit() > TickValue() * OrderLots() * pips_TP_if_more_limit_time_1 * gd_custom_2202) {
               RefreshRates();
               OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Orange);
            }
            if (TimeCurrent() - OrderOpenTime() > 60 * LimitTime_2 && TimeCurrent() - OrderOpenTime() < 60 * LimitTime_3 && OrderProfit() > TickValue() * OrderLots() * pips_TP_if_more_limit_time_2 * gd_custom_2202) {
               RefreshRates();
               OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Orange);
            }
            if (TimeCurrent() - OrderOpenTime() > 60 * LimitTime_3 && TimeCurrent() - OrderOpenTime() < 60 * LimitTime_4 && OrderProfit() > TickValue() * OrderLots() * pips_TP_if_more_limit_time_3 * gd_custom_2202) {
               RefreshRates();
               OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Orange);
            }
            if (TimeCurrent() - OrderOpenTime() > 60 * LimitTime_4 && TimeCurrent() - OrderOpenTime() < 60 * LimitTime_5 && OrderProfit() > TickValue() * OrderLots() * pips_TP_if_more_limit_time_4 * gd_custom_2202) {
               RefreshRates();
               OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Orange);
            }
            if (TimeCurrent() - OrderOpenTime() > 60 * LimitTime_5 && OrderProfit() > TickValue() * OrderLots() * pips_TP_if_more_limit_time_5 * gd_custom_2202 && GetSignal_IT(1) == 1) {
               RefreshRates();
               OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Orange);
            }
            if (CloseOnFriday == TRUE && DayOfWeek() == Friday_Days && Hour() > HourStopSession) {
               RefreshRates();
               OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Orange);
            }
         }
         if (OrderType() == OP_SELL && OrderMagicNumber() == MagicNumber_1 || OrderMagicNumber() == MagicNumber_2 || OrderMagicNumber() == MagicNumber_3) {
            if (TimeCurrent() - OrderOpenTime() > 60 * LimitTime_1 && TimeCurrent() - OrderOpenTime() < 60 * LimitTime_2 && OrderProfit() > TickValue() * OrderLots() * pips_TP_if_more_limit_time_1 * gd_custom_2202) {
               RefreshRates();
               OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Orange);
            }
            if (TimeCurrent() - OrderOpenTime() > 60 * LimitTime_2 && TimeCurrent() - OrderOpenTime() < 60 * LimitTime_3 && OrderProfit() > TickValue() * OrderLots() * pips_TP_if_more_limit_time_2 * gd_custom_2202) {
               RefreshRates();
               OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Orange);
            }
            if (TimeCurrent() - OrderOpenTime() > 60 * LimitTime_3 && TimeCurrent() - OrderOpenTime() < 60 * LimitTime_4 && OrderProfit() > TickValue() * OrderLots() * pips_TP_if_more_limit_time_3 * gd_custom_2202) {
               RefreshRates();
               OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Orange);
            }
            if (TimeCurrent() - OrderOpenTime() > 60 * LimitTime_4 && TimeCurrent() - OrderOpenTime() < 60 * LimitTime_5 && OrderProfit() > TickValue() * OrderLots() * pips_TP_if_more_limit_time_4 * gd_custom_2202) {
               RefreshRates();
               OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Orange);
            }
            if (TimeCurrent() - OrderOpenTime() > 60 * LimitTime_5 && OrderProfit() > TickValue() * OrderLots() * pips_TP_if_more_limit_time_5 * gd_custom_2202 && GetSignal_IT(0) == 1) {
               RefreshRates();
               OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Orange);
            }
            if (CloseOnFriday == TRUE && DayOfWeek() == Friday_Days && Hour() > HourStopSession) {
               RefreshRates();
               OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Orange);
            }
         }
      }
   }
   if (g_count_1300 > 0) {
      CloseAll();
      if (AccountProfitClose == TRUE) CloseAllProfit();
   }
   g_ticket_444 = NormalizeDouble(MaxTrades / 2 + 1, 0);
   if (EquityStop()) {
      if (IsTradeTime() && IsTradeTimeA()) {
         if (g_count_1300 < MaxTrades && FractalInsideEnvelope() && SpreadOK()) {
            if (Thunder_1 == TRUE) {
               RefreshRates();
               l_irsi_0 = iRSI(NULL, PERIOD_M15, 6, PRICE_CLOSE, 0);
               l_irsi_8 = iRSI(NULL, PERIOD_M1, 20, PRICE_CLOSE, 0);
               ld_16 = NormalizeDouble(iMA(NULL, 0, 8, 0, MODE_SMA, PRICE_WEIGHTED, 1), 4);
               if (l_irsi_0 < 30.0 || l_irsi_8 < 36.0 && ld_16 >= Bid + iRSI_const * 0.0001) {
                  if (g_count_1320 > 0) CloseSell_1();
                  if (gi_408 && g_count_1316 < 1 && g_count_1304 < g_ticket_444 && TimeForNextOPBuy() && SidewayTrade()) {
                     g_ticket_1292 = OrderSendReliable2Step(Symbol(), OP_BUY, GetLotsSessionA(), Ask, slp_X(), GetSL_Buy(), GetTP_Buy(), myOrderComment + "_1 " + Symbol(), MagicNumber_1, 0, Green);
                     gi_408 = FALSE;
                     gi_412 = TRUE;
                  }
               }
               if (l_irsi_0 > 70.0 || l_irsi_8 > 64.0 && ld_16 <= Bid - iRSI_const * 0.0001) {
                  if (g_count_1316 > 0) CloseBuy_1();
                  if (gi_412 && g_count_1320 < 1 && g_count_1308 < g_ticket_444 && TimeForNextOPSell() && SidewayTrade()) {
                     g_ticket_1292 = OrderSendReliable2Step(Symbol(), OP_SELL, GetLotsSessionA(), Bid, slp_X(), GetSL_Sell(), GetTP_Sell(), myOrderComment + "_1 " + Symbol(), MagicNumber_1, 0, Red);
                     gi_412 = FALSE;
                     gi_408 = TRUE;
                  }
               }
               if (l_irsi_0 < 60.0 && l_irsi_0 > 40.0) {
                  gi_412 = TRUE;
                  gi_408 = TRUE;
               }
            }
            if (Thunder_2 == TRUE) {
               l_icci_24 = iCCI(Symbol(), PERIOD_M15, 14, PRICE_CLOSE, 0);
               l_icci_32 = iCCI(Symbol(), PERIOD_M5, 42, PRICE_CLOSE, 0);
               l_icci_40 = iCCI(Symbol(), PERIOD_M1, 210, PRICE_CLOSE, 0);
               RefreshRates();
               if (g_count_1328 < 1 && g_count_1304 < g_ticket_444 && TimeForNextOPBuy() && SidewayTrade() && GetMidFractal(0) == 1 && GetMidEnvelope(0) == 1 && GetSignal_IT(0) == 1) {
                  if (g_count_1332 > 0) CloseSell_2();
                  if (gi_416 && (l_icci_32 <= -150.0 && l_icci_40 <= -120.0) || (l_icci_24 <= -150.0 && l_icci_40 <= -120.0)) {
                     g_ticket_1292 = OrderSendReliable2Step(Symbol(), OP_BUY, GetLotsSessionA(), Ask, slp_X(), GetSL_Buy(), GetTP_Buy(), myOrderComment + "_2 " + Symbol(), MagicNumber_2, 0, Green);
                     gi_416 = FALSE;
                     gi_420 = TRUE;
                  }
               }
               if (g_count_1332 < 1 && g_count_1308 < g_ticket_444 && TimeForNextOPSell() && SidewayTrade() && GetMidFractal(1) == 1 && GetMidEnvelope(1) == 1 && GetSignal_IT(1) == 1) {
                  if (g_count_1328 > 0) CloseBuy_2();
                  if (gi_420 && (l_icci_32 >= 150.0 && l_icci_40 >= 120.0) || (l_icci_24 >= 150.0 && l_icci_40 >= 120.0)) {
                     g_ticket_1292 = OrderSendReliable2Step(Symbol(), OP_SELL, GetLotsSessionA(), Bid, slp_X(), GetSL_Sell(), GetTP_Sell(), myOrderComment + "_2 " + Symbol(), MagicNumber_2, 0, Red);
                     gi_420 = FALSE;
                     gi_416 = TRUE;
                  }
               }
               if (l_icci_24 < 50.0 && l_icci_24 > -50.0) {
                  gi_420 = TRUE;
                  gi_416 = TRUE;
               }
            }
            if (Thunder_3 == TRUE) {
               l_icustom_48 = iCustom(Symbol(), PERIOD_M1, "MA_AngleZeroSigma", MA_AngleZero_const_1, MA_AngleZero_const_2, MA_AngleZero_const_3, MA_AngleZero_const_4, MA_AngleZero_const_5, MA_AngleZero_const_6, MA_AngleZero_const_7, MA_AngleZero_const_8, "", "", 4, 0);
               RefreshRates();
               if (gi_1364 < 1 && GetMidFractal(0) == 1 && GetMidEnvelope(0) == 1 && GetSignal_IT(0) == 1 && l_icustom_48 <= -0.12) {
                  if (g_count_1344 > 0) CloseSell_3();
                  if (gi_424 && TimeForNextOPBuy() && g_count_1304 < g_ticket_444 && SidewayTrade()) {
                     g_ticket_1292 = OrderSendReliable2Step(Symbol(), OP_BUY, GetLotsSessionA(), Ask, slp_X(), GetSL_Buy(), GetTP_Buy(), myOrderComment + "_3 " + Symbol(), MagicNumber_3, 0, Blue);
                     gi_428 = TRUE;
                  }
               }
               RefreshRates();
               if (MaxTrades > 2 && GetMidFractal(0) == 1 && GetSignal_IT(0) == 1 && l_icustom_48 <= -0.12) {
                  if (g_count_1344 > 0) CloseSell_3();
                  if (gi_424 && TimeForNextOPBuy() && gi_1364 > 0 && gi_1364 < g_ticket_444 && g_count_1304 < g_ticket_444 && SidewayTrade()) {
                     g_ticket_1292 = OrderSendReliable2Step(Symbol(), OP_BUY, GetLotsSessionA(), Ask, slp_X(), GetSL_Buy(), GetTP_Buy(), myOrderComment + "_3 " + Symbol(), MagicNumber_3, 0, Blue);
                     gi_428 = TRUE;
                     gi_424 = FALSE;
                  }
               }
               RefreshRates();
               if (gi_1368 < 1 && GetMidFractal(1) == 1 && GetMidEnvelope(1) == 1 && GetSignal_IT(1) == 1 && l_icustom_48 >= 0.12) {
                  if (g_count_1340 > 0) CloseBuy_3();
                  if (gi_428 && TimeForNextOPSell() && g_count_1308 < g_ticket_444 && SidewayTrade()) {
                     g_ticket_1292 = OrderSendReliable2Step(Symbol(), OP_SELL, GetLotsSessionA(), Bid, slp_X(), GetSL_Sell(), GetTP_Sell(), myOrderComment + "_3 " + Symbol(), MagicNumber_3, 0, Red);
                     gi_424 = TRUE;
                  }
               }
               RefreshRates();
               if (MaxTrades > 2 && GetMidFractal(1) == 1 && GetSignal_IT(1) == 1 && l_icustom_48 >= 0.12) {
                  if (g_count_1340 > 0) CloseBuy_3();
                  if (gi_428 && TimeForNextOPSell() && gi_1368 > 0 && gi_1368 < g_ticket_444 && g_count_1308 < g_ticket_444 && SidewayTrade()) {
                     g_ticket_1292 = OrderSendReliable2Step(Symbol(), OP_SELL, GetLotsSessionA(), Bid, slp_X(), GetSL_Sell(), GetTP_Sell(), myOrderComment + "_3 " + Symbol(), MagicNumber_3, 0, Red);
                     gi_424 = TRUE;
                     gi_428 = FALSE;
                  }
               }
               if (l_icustom_48 < 0.1 && l_icustom_48 > -0.1) {
                  gi_428 = TRUE;
                  gi_424 = TRUE;
               }
            }
         }
      }
   }
   return (0);
}

bool IsTradeTime() {
   if (HourStartSession < HourStopSession && TimeHour(TimeCurrent()) < HourStartSession || TimeHour(TimeCurrent()) >= HourStopSession) return (FALSE);
   if (HourStartSession > HourStopSession && TimeHour(TimeCurrent()) < HourStartSession && TimeHour(TimeCurrent()) >= HourStopSession) return (FALSE);
   if (HourStopSession == 0) HourStopSession = 24;
   if (Hour() == HourStopSession && Minute() >= gi_404) return (FALSE);
   return (TRUE);
}

int IsTradeTimeA() {
   if (TradeOnFriday == FALSE && DayOfWeek() == Friday_Days && Hour() >= HourStartSession) return (0);
   if (TradeOnFriday == FALSE && DayOfWeek() == Friday_Days && TotalOpens() < 1) return (0);
   if (DayOfWeek() == Friday_Days && Hour() >= HourStopSession) return (0);
   return (1);
}

int SpreadOK() {
   if (NormalizeDouble(MarketInfo(Symbol(), MODE_SPREAD), 1) > msprd_X()) {
      Print("SPREAD More Than msprd_X() ", MaxSpread);
      return (0);
   }
   return (1);
}

double SetPoint() {
   double ld_ret_0;
   if (Digits == 5 || Digits == 3) ld_ret_0 = 0.00001;
   else ld_ret_0 = 0.0001;
   return (ld_ret_0);
}

int TotalOpens() {
   RefreshRates();
   int l_count_0 = 0;
   for (g_pos_1296 = 0; g_pos_1296 < OrdersTotal(); g_pos_1296++) {
      OrderSelect(g_pos_1296, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_1 || OrderMagicNumber() == MagicNumber_2 || OrderMagicNumber() == MagicNumber_3 && OrderCloseTime() == 0) l_count_0++;
   }
   return (l_count_0);
}

double GetTP_Buy() {
   double ld_ret_0 = 0;
   if (Hidden_TP == TRUE && Hide_ALL == FALSE) ld_ret_0 = Ask + TP_Fake_X() * gd_custom_2201;
   else ld_ret_0 = 0;
   return (ld_ret_0);
}

double GetSL_Buy() {
   double ld_ret_0 = 0;
   if (Hidden_SL == FALSE && Hide_ALL == FALSE) ld_ret_0 = Ask - SL_X() * gd_custom_2201;
   else {
      if (Hidden_SL == TRUE && Hide_ALL == FALSE) ld_ret_0 = Ask - 1.7 * SL_X() * gd_custom_2201;
      else ld_ret_0 = 0;
   }
   return (ld_ret_0);
}

double GetTP_Sell() {
   double ld_ret_0 = 0;
   if (Hidden_TP == TRUE && Hide_ALL == FALSE) ld_ret_0 = Bid - TP_Fake_X() * gd_custom_2201;
   else ld_ret_0 = 0;
   return (ld_ret_0);
}

double GetSL_Sell() {
   double ld_ret_0 = 0;
   if (Hidden_SL == FALSE && Hide_ALL == FALSE) ld_ret_0 = Bid + SL_X() * gd_custom_2201;
   else {
      if (Hidden_SL == TRUE && Hide_ALL == FALSE) ld_ret_0 = Bid + 1.7 * SL_X() * gd_custom_2201;
      else ld_ret_0 = 0;
   }
   return (ld_ret_0);
}

int SetBroker() {
   double ld_ret_0;
   if (Digits == 5 || Digits == 3) ld_ret_0 = 10;
   else ld_ret_0 = 1;
   return (ld_ret_0);
}

int CloseTime() {
   if (TimeCurrent() - OrderOpenTime() < 60 * MinuteForClose) return (0);
   return (1);
}

int TimeForNextOPBuy() {
   RefreshRates();
   if (TotalOpens() > 0 && OrderOpenPrice() - Ask < PrFrLastOP() * gd_custom_2201) return (0);
   if (TotalOpens() > 0 && TimeCurrent() - OrderOpenTime() < 60 * MinuteforNextOP) return (0);
   return (1);
}

int TimeForNextOPSell() {
   RefreshRates();
   if (TotalOpens() > 0 && Bid - OrderOpenPrice() < PrFrLastOP() * gd_custom_2201) return (0);
   if (TotalOpens() > 0 && TimeCurrent() - OrderOpenTime() < 60 * MinuteforNextOP) return (0);
   return (1);
}

double RangeDAY() {
   double l_ihigh_0 = 0;
   double l_ihigh_8 = 0;
   double l_ihigh_16 = 0;
   double l_ihigh_24 = 0;
   double l_ihigh_32 = 0;
   double l_ilow_40 = 0;
   double l_ilow_48 = 0;
   double l_ilow_56 = 0;
   double l_ilow_64 = 0;
   double l_ilow_72 = 0;
   double ld_80 = 0;
   double ld_88 = 0;
   double ld_96 = 0;
   double ld_104 = 0;
   double ld_112 = 0;
   double ld_ret_120 = 0;
   double ld_128 = 0;
   l_ihigh_0 = iHigh(Symbol(), PERIOD_D1, 1);
   l_ilow_40 = iLow(Symbol(), PERIOD_D1, 1);
   l_ihigh_8 = iHigh(Symbol(), PERIOD_D1, 2);
   l_ilow_48 = iLow(Symbol(), PERIOD_D1, 2);
   l_ihigh_16 = iHigh(Symbol(), PERIOD_D1, 3);
   l_ilow_56 = iLow(Symbol(), PERIOD_D1, 3);
   l_ihigh_24 = iHigh(Symbol(), PERIOD_D1, 4);
   l_ilow_64 = iLow(Symbol(), PERIOD_D1, 4);
   l_ihigh_32 = iHigh(Symbol(), PERIOD_D1, 5);
   l_ilow_72 = iLow(Symbol(), PERIOD_D1, 5);
   ld_80 = l_ihigh_0 - l_ilow_40;
   ld_88 = l_ihigh_8 - l_ilow_48;
   ld_96 = l_ihigh_16 - l_ilow_56;
   ld_104 = l_ihigh_24 - l_ilow_64;
   ld_112 = l_ihigh_32 - l_ilow_72;
   ld_128 = (ld_80 + ld_88 + ld_96 + ld_104 + ld_112) / Per_RangeD_Avg;
   if (ld_128 < RangeD_Min * gd_custom_2201) ld_ret_120 = RangeD_Min * gd_custom_2201;
   else ld_ret_120 = ld_128;
   return (ld_ret_120);
}

int SidewayTrade() {
   double l_icustom_0 = iCustom(Symbol(), PERIOD_M30, "Damiani_Volt", 5, 8, 40, 100, 1.2, 1, 0.5, 0, 0);
   double l_icustom_8 = iCustom(Symbol(), PERIOD_M30, "Damiani_Volt", 5, 8, 40, 100, 1.2, 1, 0.5, 1, 0);
   double l_icustom_16 = iCustom(Symbol(), PERIOD_M30, "Damiani_Volt", 5, 8, 40, 100, 1.2, 1, 0.5, 2, 0);
   double l_icustom_24 = iCustom(Symbol(), PERIOD_M15, "Damiani_Volt", 5, 8, 40, 100, 1.4, 1, 0.5, 0, 0);
   double l_icustom_32 = iCustom(Symbol(), PERIOD_M15, "Damiani_Volt", 5, 8, 40, 100, 1.4, 1, 0.5, 1, 0);
   double l_icustom_40 = iCustom(Symbol(), PERIOD_M15, "Damiani_Volt", 5, 8, 40, 100, 1.4, 1, 0.5, 2, 0);
   if (Use_Damiani_Filter == TRUE && l_icustom_0 < l_icustom_16 && l_icustom_24 < l_icustom_40) return (0);
   return (1);
}

int GetSignal_IT(int ai_0) {
   RefreshRates();
   double l_icustom_4 = iCustom(Symbol(), PERIOD_M5, "i_Trend", 0, 0, 0, 20, 2, 13, 100, 0, 0);
   double l_icustom_12 = iCustom(Symbol(), PERIOD_M5, "i_Trend", 0, 0, 0, 20, 2, 13, 100, 1, 0);
   bool li_ret_20 = FALSE;
   if (ai_0 == 0) {
      if (l_icustom_4 < i_Trend_Level && l_icustom_4 > (-i_Trend_Level) && l_icustom_12 < i_Trend_Level && l_icustom_12 > (-i_Trend_Level) && l_icustom_4 < l_icustom_12) li_ret_20 = TRUE;
   } else {
      if (ai_0 == 1)
         if (l_icustom_4 < i_Trend_Level && l_icustom_4 > (-i_Trend_Level) && l_icustom_12 < i_Trend_Level && l_icustom_12 > (-i_Trend_Level) && l_icustom_4 > l_icustom_12) li_ret_20 = TRUE;
   }
   return (li_ret_20);
}

int GetMidEnvelope(int ai_0) {
   RefreshRates();
   bool li_ret_4 = FALSE;
   double l_ienvelopes_8 = iEnvelopes(Symbol(), PERIOD_M1, 15, MODE_LWMA, 0, PRICE_CLOSE, 0.07, MODE_UPPER, 1);
   double l_ienvelopes_16 = iEnvelopes(Symbol(), PERIOD_M1, 15, MODE_LWMA, 0, PRICE_CLOSE, 0.07, MODE_LOWER, 1);
   double l_ienvelopes_24 = iEnvelopes(Symbol(), PERIOD_M1, 60, MODE_LWMA, 0, PRICE_CLOSE, 0.1, MODE_UPPER, 1);
   double l_ienvelopes_32 = iEnvelopes(Symbol(), PERIOD_M1, 60, MODE_LWMA, 0, PRICE_CLOSE, 0.1, MODE_LOWER, 1);
   double l_ienvelopes_40 = iEnvelopes(Symbol(), PERIOD_M1, 120, MODE_LWMA, 0, PRICE_CLOSE, 0.15, MODE_UPPER, 14);
   double l_ienvelopes_48 = iEnvelopes(Symbol(), PERIOD_M1, 120, MODE_LWMA, 0, PRICE_CLOSE, 0.15, MODE_LOWER, 14);
   gd_784 = l_ienvelopes_8 - l_ienvelopes_8;
   gd_760 = l_ienvelopes_40 - (l_ienvelopes_40 - l_ienvelopes_48) / 2.0;
   if (ai_0 == 0) {
      if (Bid <= gd_760 - PrFrMid() * gd_custom_2201) li_ret_4 = TRUE;
   } else {
      if (ai_0 == 1)
         if (Bid >= gd_760 + PrFrMid() * gd_custom_2201) li_ret_4 = TRUE;
   }
   return (li_ret_4);
}

int GetMidFractal(int ai_0) {
   RefreshRates();
   bool li_ret_4 = FALSE;
   for (int li_8 = 1; li_8 < Bars; li_8++) {
      if (iFractals(NULL, PERIOD_M15, MODE_UPPER, li_8) != 0.0) {
         g_ifractals_664 = iFractals(NULL, PERIOD_M15, MODE_UPPER, li_8);
         gd_unused_688 = Time[li_8];
         break;
      }
   }
   for (int li_12 = 1; li_12 < Bars; li_12++) {
      if (iFractals(NULL, PERIOD_M15, MODE_LOWER, li_12) != 0.0) {
         g_ifractals_672 = iFractals(NULL, PERIOD_M15, MODE_LOWER, li_12);
         gd_unused_680 = Time[li_12];
         break;
      }
   }
   gd_744 = g_ifractals_664 - (g_ifractals_664 - g_ifractals_672) / 2.0;
   if (ai_0 == 0) {
      if (Bid <= gd_744 - OPFrFrctl() * gd_custom_2201) li_ret_4 = TRUE;
   } else {
      if (ai_0 == 1)
         if (Bid >= gd_744 + OPFrFrctl() * gd_custom_2201) li_ret_4 = TRUE;
   }
   return (li_ret_4);
}

int FractalInsideEnvelope() {
   RefreshRates();
   for (int li_0 = 1; li_0 < Bars; li_0++) {
      if (iFractals(NULL, PERIOD_H1, MODE_UPPER, li_0) != 0.0) {
         g_ifractals_696 = iFractals(NULL, PERIOD_H1, MODE_UPPER, li_0);
         gd_unused_720 = Time[li_0];
         break;
      }
   }
   for (int li_4 = 1; li_4 < Bars; li_4++) {
      if (iFractals(NULL, PERIOD_H1, MODE_LOWER, li_4) != 0.0) {
         g_ifractals_704 = iFractals(NULL, PERIOD_H1, MODE_LOWER, li_4);
         gd_unused_712 = Time[li_4];
         break;
      }
   }
   if (Bid > g_ifractals_696 || Bid < g_ifractals_704) return (0);
   return (1);
}

double GetLotsSessionA() {
   double ld_ret_0;
   double ld_32;
   double l_lotsize_40 = MarketInfo(Symbol(), MODE_LOTSIZE);
   double ld_16 = NormalizeDouble(MarketInfo(Symbol(), MODE_MINLOT), 2);
   double ld_24 = NormalizeDouble(MarketInfo(Symbol(), MODE_MAXLOT), 2);
   if (LotsOptimized == TRUE) ld_ret_0 = NormalizeDouble(AccountFreeMargin() * Risk / l_lotsize_40 / MaxTrades, GetLotDecimal());
   else ld_ret_0 = Lots;
   if (ld_ret_0 < ld_16) ld_ret_0 = ld_16;
   if (MaxLots > 0.0 && MaxLots < ld_24) ld_32 = MaxLots;
   else ld_32 = ld_24;
   if (ld_ret_0 > ld_32) ld_ret_0 = ld_32;
   if (AccountFreeMarginCheck(Symbol(), OP_BUY, ld_ret_0) <= 0.0 || GetLastError() == 134/* NOT_ENOUGH_MONEY */) Print("We have no money.Reduce your Lots! Free Margin = ", AccountFreeMargin());
   return (ld_ret_0);
}

int GetLotDecimal() {
   double ld_ret_0;
   double ld_8 = NormalizeDouble(MarketInfo(Symbol(), MODE_LOTSTEP), 2);
   if (Auto_LotsDecimal == TRUE) {
      if (ld_8 == 0.01) ld_ret_0 = 2;
      else {
         if (ld_8 == 0.1) ld_ret_0 = 1;
         else ld_ret_0 = 0;
      }
   } else ld_ret_0 = LotsDecimal;
   return (ld_ret_0);
}

double TickValue() {
   double ld_0;
   ld_0 = NormalizeDouble(MarketInfo(Symbol(), MODE_TICKVALUE), Digits);
   return (ld_0);
}

int myProfit() {
   bool li_ret_0 = FALSE;
   if (OrderProfit() > TickValue() * GetLotsSessionA() * TP_X()) li_ret_0 = TRUE;
   return (li_ret_0);
}

int AllProfit() {
   bool li_ret_0 = FALSE;
   if (AccountProfit() > TickValue() * GetLotsSessionA() * TP_X()) li_ret_0 = TRUE;
   return (li_ret_0);
}

bool EquityStop() {
   RefreshRates();
   if (TargetEquity != 0.0 && AccountEquity() > TargetEquity) return (FALSE);
   return (TRUE);
}

void CloseAllProfit() {
   for (g_pos_1296 = OrdersTotal()-1; g_pos_1296 >=0 ; g_pos_1296--) {
      OrderSelect(g_pos_1296, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_1 || OrderMagicNumber() == MagicNumber_2 || OrderMagicNumber() == MagicNumber_3 && OrderCloseTime() == 0) {
         if (CloseTime() && AllProfit() == 1) {
            if (OrderType() == OP_BUY) OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Blue);
            if (OrderType() == OP_SELL) OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Red);
         }
      }
   }
}

void CloseAllNow() {
   for (int l_pos_0 = OrdersTotal() - 1; l_pos_0 >= 0; l_pos_0--) {
      OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_1 || OrderMagicNumber() == MagicNumber_2 || OrderMagicNumber() == MagicNumber_3 && OrderCloseTime() == 0) {
         if (OrderType() == OP_BUY) OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Blue);
         if (OrderType() == OP_SELL) OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Red);
      }
   }
}

void CloseAll() {
   for (int l_pos_0 = OrdersTotal() - 1; l_pos_0 >= 0; l_pos_0--) {
      OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_1 || OrderMagicNumber() == MagicNumber_2 || OrderMagicNumber() == MagicNumber_3 && OrderCloseTime() == 0) {
         if (CloseTime() && myProfit() == 1) {
            if (OrderType() == OP_BUY && Hidden_TP == TRUE) OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Blue);
            if (OrderType() == OP_SELL && Hidden_TP == TRUE) OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Red);
         } else {
            if (IsTradeTime()) {
               if (OrderType() == OP_BUY && !SidewayTrade() && OrderProfit() < TickValue() * OrderLots() * (-SL_X())) OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Blue);
               if (OrderType() == OP_SELL && !SidewayTrade() && OrderProfit() < TickValue() * OrderLots() * (-SL_X())) OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Red);
            } else {
               if (OrderType() == OP_BUY && GetSignal_IT(0) != 1 && OrderProfit() < TickValue() * OrderLots() * (-SL2_X())) OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Blue);
               if (OrderType() == OP_SELL && GetSignal_IT(1) != 1 && OrderProfit() < TickValue() * OrderLots() * (-SL2_X())) OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Red);
            }
         }
      }
   }
}

double SL_X() {
   double ld_ret_0 = 0;
   if (AutoRange_SL == TRUE) ld_ret_0 = RangeDAY() / Per_RangeD_SL / gd_custom_2201;
   else ld_ret_0 = StopLoss * gd_custom_2202;
   if (ld_ret_0 <= StopLoss - gd_custom_2202 << 2 || ld_ret_0 >= StopLoss + gd_custom_2202 << 2) ld_ret_0 = StopLoss * gd_custom_2202;
   return (ld_ret_0);
}

double SL2_X() {
   double ld_ret_0 = 0;
   if (AutoRange_TP == TRUE) ld_ret_0 = RangeDAY() / Per_RangeD_SL_Out / gd_custom_2201;
   else ld_ret_0 = SL_OutSession * gd_custom_2202;
   if (ld_ret_0 <= SL_OutSession - 6 * gd_custom_2202 || ld_ret_0 >= SL_OutSession + 6 * gd_custom_2202) ld_ret_0 = SL_OutSession * gd_custom_2202;
   return (ld_ret_0);
}

double TP_X() {
   double ld_ret_0 = 0;
   if (AutoRange_TP == TRUE) ld_ret_0 = RangeDAY() / Per_RangeD_TP / gd_custom_2201;
   else ld_ret_0 = TakeProfit * gd_custom_2202;
   if (ld_ret_0 <= TakeProfit - gd_custom_2202 << 1 || ld_ret_0 >= TakeProfit + gd_custom_2202 << 1) ld_ret_0 = TakeProfit * gd_custom_2202;
   return (ld_ret_0);
}

double TP_Fake_X() {
   double ld_ret_0 = 0;
   if (AutoRange_TP == TRUE) ld_ret_0 = RangeDAY() / Per_RangeD_TP / gd_custom_2201;
   else ld_ret_0 = TakeProfit_FAKE * gd_custom_2202;
   if (ld_ret_0 <= TakeProfit_FAKE * gd_custom_2202 || ld_ret_0 >= TakeProfit_FAKE * gd_custom_2202) ld_ret_0 = TakeProfit_FAKE * gd_custom_2202;
   return (ld_ret_0);
}

double slp_X() {
   double ld_ret_0 = Slippage * gd_custom_2202;
   return (ld_ret_0);
}

double msprd_X() {
   double ld_ret_0 = MaxSpread * gd_custom_2202;
   return (ld_ret_0);
}

double PrFrLastOP() {
   double ld_ret_0;
   if (AutoPriceFromLast == TRUE) ld_ret_0 = RangeDAY() / Per_RangeD_OP / gd_custom_2201;
   else ld_ret_0 = PriceFromLastOP * gd_custom_2202;
   if (ld_ret_0 <= PriceFromLastOP - gd_custom_2202 << 1 || ld_ret_0 >= PriceFromLastOP + gd_custom_2202 << 1) ld_ret_0 = PriceFromLastOP * gd_custom_2202;
   return (ld_ret_0);
}

double OPFrFrctl() {
   double ld_ret_0;
   if (AutoPriceFractal == TRUE) ld_ret_0 = RangeDAY() / Per_RangeD_Fractal / gd_custom_2201;
   else ld_ret_0 = OPFromFractal * gd_custom_2202;
   if (ld_ret_0 <= OPFromFractal - gd_custom_2202 << 1 || ld_ret_0 >= OPFromFractal + gd_custom_2202 << 1) ld_ret_0 = OPFromFractal * gd_custom_2202;
   return (ld_ret_0);
}

double PrFrMid() {
   double ld_ret_0;
   if (AutoPriceMid == TRUE) ld_ret_0 = RangeDAY() / AutoPriceMid / gd_custom_2201;
   else ld_ret_0 = PriceFromMid * gd_custom_2202;
   if (ld_ret_0 <= PriceFromMid - gd_custom_2202 << 1 || ld_ret_0 >= PriceFromMid + gd_custom_2202 << 1) ld_ret_0 = PriceFromMid * gd_custom_2202;
   return (ld_ret_0);
}

void CloseBuy_1() {
   for (int l_pos_0 = OrdersTotal() - 1; l_pos_0 >= 0; l_pos_0--) {
      OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_1)
         if (OrderType() == OP_BUY && OrderProfit() < TickValue() * OrderLots() * 2.0 * (-pips_SL_for_emergency_trend) * gd_custom_2202) OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Blue);
   }
}

void CloseSell_1() {
   for (int l_pos_0 = OrdersTotal() - 1; l_pos_0 >= 0; l_pos_0--) {
      OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_1)
         if (OrderType() == OP_SELL && OrderProfit() < TickValue() * OrderLots() * 2.0 * (-pips_SL_for_emergency_trend) * gd_custom_2202) OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Red);
   }
}

void CloseBuy_2() {
   for (int l_pos_0 = OrdersTotal() - 1; l_pos_0 >= 0; l_pos_0--) {
      OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_2)
         if (OrderType() == OP_BUY && OrderProfit() < TickValue() * OrderLots() * 2.0 * (-pips_SL_for_emergency_trend) * gd_custom_2202) OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Blue);
   }
}

void CloseSell_2() {
   for (int l_pos_0 = OrdersTotal() - 1; l_pos_0 >= 0; l_pos_0--) {
      OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_2)
         if (OrderType() == OP_SELL && OrderProfit() < TickValue() * OrderLots() * 2.0 * (-pips_SL_for_emergency_trend) * gd_custom_2202) OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Red);
   }
}

void CloseBuy_3() {
   for (int l_pos_0 = OrdersTotal() - 1; l_pos_0 >= 0; l_pos_0--) {
      OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_3)
         if (OrderType() == OP_BUY && OrderProfit() < TickValue() * OrderLots() * 2.0 * (-pips_SL_for_emergency_trend) * gd_custom_2202) OrderCloseReliable(OrderTicket(), OrderLots(), Bid, slp_X(), Blue);
   }
}

void CloseSell_3() {
   for (int l_pos_0 = OrdersTotal() - 1; l_pos_0 >= 0; l_pos_0--) {
      OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber_3)
         if (OrderType() == OP_SELL && OrderProfit() < TickValue() * OrderLots() * 2.0 * (-pips_SL_for_emergency_trend) * gd_custom_2202) OrderCloseReliable(OrderTicket(), OrderLots(), Ask, slp_X(), Red);
   }
}




//=============================================================================
//							 OrderSendReliable()
//
//  This is intended to be a drop-in replacement for OrderSend() which, 
//  one hopes, is more resistant to various forms of errors prevalent 
//  with MetaTrader.
//			  
//	RETURN VALUE: 
//
//  Ticket number or -1 under some error conditions.  Check
//  final error returned by Metatrader with OrderReliableLastErr().
//  This will reset the value from GetLastError(), so in that sense it cannot
//  be a total drop-in replacement due to Metatrader flaw. 
//
//  FEATURES:
//
//     * Re-trying under some error conditions, sleeping a random 
//       time defined by an exponential probability distribution.
//
//     * Automatic normalization of Digits
//
//     * Automatically makes sure that stop levels are more than
//       the minimum stop distance, as given by the server. If they
//       are too close, they are adjusted.
//
//     * Automatically converts stop orders to market orders 
//       when the stop orders are rejected by the server for 
//       being to close to market.  NOTE: This intentionally
//       applies only to OP_BUYSTOP and OP_SELLSTOP, 
//       OP_BUYLIMIT and OP_SELLLIMIT are not converted to market
//       orders and so for prices which are too close to current
//       this function is likely to loop a few times and return
//       with the "invalid stops" error message. 
//       Note, the commentary in previous versions erroneously said
//       that limit orders would be converted.  Note also
//       that entering a BUYSTOP or SELLSTOP new order is distinct
//       from setting a stoploss on an outstanding order; use
//       OrderModifyReliable() for that. 
//
//     * Displays various error messages on the log for debugging.
//
//
//	Matt Kennel, 2006-05-28 and following
//
//=============================================================================
int OrderSendReliable(string symbol, int cmd, double volume, double price,
					  int slippage, double stoploss, double takeprofit,
					  string comment, int magic, datetime expiration = 0, 
					  color arrow_color = CLR_NONE) 
{

	// ------------------------------------------------
	// Check basic conditions see if trade is possible. 
	// ------------------------------------------------
		price = NormalizeDouble(price, Digits);
		stoploss = NormalizeDouble(stoploss, Digits);
		takeprofit = NormalizeDouble(takeprofit, Digits);			

	OrderReliable_Fname = "OrderSendReliable";
	OrderReliablePrint(" attempted " + OrderReliable_CommandString(cmd) + " " + volume + 
						" lots @" + price + " sl:" + stoploss + " tp:" + takeprofit); 
						
	if (!IsConnected()) 
	{
		OrderReliablePrint("error: IsConnected() == false");
		_OR_err = ERR_NO_CONNECTION; 
		return(-1);
	}
	
	if (IsStopped()) 
	{
		OrderReliablePrint("error: IsStopped() == true");
		_OR_err = ERR_COMMON_ERROR; 
		return(-1);
	}
	
	int cnt = 0;
	while(!IsTradeAllowed() && cnt < retry_attempts) 
	{
		OrderReliable_SleepRandomTime(sleep_time, sleep_maximum); 
		cnt++;
	}
	
	if (!IsTradeAllowed()) 
	{
		if (ErrorLevel > 1)
			OrderReliablePrint("error: no operation possible because IsTradeAllowed()==false, even after retries.");
		_OR_err = ERR_TRADE_CONTEXT_BUSY; 

		return(-1);  
	}

	// Normalize all price / stoploss / takeprofit to the proper # of digits.
	int digits = MarketInfo(symbol, MODE_DIGITS);
	Print("Digits: ",Digits,"digits: ",digits);
	if (digits > 0) 
	{
		price = NormalizeDouble(price, digits);
		stoploss = NormalizeDouble(stoploss, digits);
		takeprofit = NormalizeDouble(takeprofit, digits); 
	}
	
	if (stoploss != 0) 
		OrderReliable_EnsureValidStop(symbol, price, stoploss); 

	int err = GetLastError(); // clear the global variable.  
	err = 0; 
	_OR_err = 0; 
	bool exit_loop = false;
	bool limit_to_market = false; 
	
	// limit/stop order. 
	int ticket=-1;

	if ((cmd == OP_BUYSTOP) || (cmd == OP_SELLSTOP) || (cmd == OP_BUYLIMIT) || (cmd == OP_SELLLIMIT)) 
	{
		cnt = 0;
		while (!exit_loop) 
		{
			if (IsTradeAllowed()) 
			{
				ticket = OrderSend(symbol, cmd, volume, price, slippage, stoploss, 
									takeprofit, comment, magic, expiration, arrow_color);
				err = GetLastError();
				_OR_err = err; 
			} 
			else 
			{
				cnt++;
			} 
			
			switch (err) 
			{
				case ERR_NO_ERROR:
					exit_loop = true;
					break;
				
				// retryable errors
				case ERR_SERVER_BUSY:
				case ERR_NO_CONNECTION:
				case ERR_INVALID_PRICE:
				case ERR_OFF_QUOTES:
				case ERR_BROKER_BUSY:
				case ERR_TRADE_CONTEXT_BUSY: 
					cnt++; 
					break;
					
				case ERR_PRICE_CHANGED:
				case ERR_REQUOTE:
					RefreshRates();
					continue;	// we can apparently retry immediately according to MT docs.
					
				case ERR_INVALID_STOPS:
					double servers_min_stop = MarketInfo(symbol, MODE_STOPLEVEL) * MarketInfo(symbol, MODE_POINT); 
					if (cmd == OP_BUYSTOP) 
					{
						// If we are too close to put in a limit/stop order so go to market.
						if (MathAbs(Ask - price) <= servers_min_stop)	
							limit_to_market = true; 
							
					} 
					else if (cmd == OP_SELLSTOP) 
					{
						// If we are too close to put in a limit/stop order so go to market.
						if (MathAbs(Bid - price) <= servers_min_stop)
							limit_to_market = true; 
					}
					exit_loop = true; 
					break; 
					
				default:
					// an apparently serious error.
					exit_loop = true;
					break; 
					
			}  // end switch 

			if (cnt > retry_attempts) 
				exit_loop = true; 
			 	
			if (exit_loop) 
			{
				if (err != ERR_NO_ERROR) 
				{
					OrderReliablePrint("non-retryable error: " + OrderReliableErrTxt(err)); 
				}
				if (cnt > retry_attempts) 
				{
					OrderReliablePrint("retry attempts maxed at " + retry_attempts); 
				}
			}
			 
			if (!exit_loop) 
			{
				OrderReliablePrint("retryable error (" + cnt + "/" + retry_attempts + 
									"): " + OrderReliableErrTxt(err)); 
				OrderReliable_SleepRandomTime(sleep_time, sleep_maximum); 
				RefreshRates(); 
			}
		}
		 
		// We have now exited from loop. 
		if (err == ERR_NO_ERROR) 
		{
			OrderReliablePrint("apparently successful OP_BUYSTOP or OP_SELLSTOP order placed, details follow.");
			OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES); 
			OrderPrint(); 
			return(ticket); // SUCCESS! 
		} 
		if (!limit_to_market) 
		{
			OrderReliablePrint("failed to execute stop or limit order after " + cnt + " retries");
			OrderReliablePrint("failed trade: " + OrderReliable_CommandString(cmd) + " " + symbol + 
								"@" + price + " tp@" + takeprofit + " sl@" + stoploss); 
			OrderReliablePrint("last error: " + OrderReliableErrTxt(err)); 
			return(-1); 
		}
	}  // end	  
  
	if (limit_to_market) 
	{
		OrderReliablePrint("going from limit order to market order because market is too close.");
		if ((cmd == OP_BUYSTOP) || (cmd == OP_BUYLIMIT)) 
		{
			cmd = OP_BUY;
			price = Ask;
		} 
		else if ((cmd == OP_SELLSTOP) || (cmd == OP_SELLLIMIT)) 
		{
			cmd = OP_SELL;
			price = Bid;
		}	
	}
	
	// we now have a market order.
	err = GetLastError(); // so we clear the global variable.  
	err = 0; 
	_OR_err = 0; 
	ticket = -1;

	if ((cmd == OP_BUY) || (cmd == OP_SELL)) 
	{
		cnt = 0;
		while (!exit_loop) 
		{
			if (IsTradeAllowed()) 
			{
				ticket = OrderSend(symbol, cmd, volume, price, slippage, 
									stoploss, takeprofit, comment, magic, 
									expiration, arrow_color);
				err = GetLastError();
				_OR_err = err; 
			} 
			else 
			{
				cnt++;
			} 
			switch (err) 
			{
				case ERR_NO_ERROR:
					exit_loop = true;
					break;
					
				case ERR_SERVER_BUSY:
				case ERR_NO_CONNECTION:
				case ERR_INVALID_PRICE:
				case ERR_OFF_QUOTES:
				case ERR_BROKER_BUSY:
				case ERR_TRADE_CONTEXT_BUSY: 
					cnt++; // a retryable error
					break;
					
				case ERR_PRICE_CHANGED:
				case ERR_REQUOTE:
					RefreshRates();
					continue; // we can apparently retry immediately according to MT docs.
					
				default:
					// an apparently serious, unretryable error.
					exit_loop = true;
					break; 
					
			}  // end switch 

			if (cnt > retry_attempts) 
			 	exit_loop = true; 
			 	
			if (!exit_loop) 
			{
				OrderReliablePrint("retryable error (" + cnt + "/" + 
									retry_attempts + "): " + OrderReliableErrTxt(err)); 
				OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
				RefreshRates(); 
			}
			
			if (exit_loop) 
			{
				if (err != ERR_NO_ERROR) 
				{
					OrderReliablePrint("non-retryable error: " + OrderReliableErrTxt(err)); 
				}
				if (cnt > retry_attempts) 
				{
					OrderReliablePrint("retry attempts maxed at " + retry_attempts); 
				}
			}
		}
		
		// we have now exited from loop. 
		if (err == ERR_NO_ERROR) 
		{
			OrderReliablePrint("apparently successful OP_BUY or OP_SELL order placed, details follow.");
			OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES); 
			OrderPrint(); 
			return(ticket); // SUCCESS! 
		} 
		OrderReliablePrint("failed to execute OP_BUY/OP_SELL, after " + cnt + " retries");
		OrderReliablePrint("failed trade: " + OrderReliable_CommandString(cmd) + " " + symbol + 
							"@" + price + " tp@" + takeprofit + " sl@" + stoploss); 
		OrderReliablePrint("last error: " + OrderReliableErrTxt(err)); 
		return(-1); 
	}
}

//=============================================================================
//							 OrderSendReliable2Step()
//
//  Some brokers don't allow the SL and TP settings as part of the initial market order (Water House Capital)
//  Therefore, this routine will first place the market order with no stop-loss and take-profit but later
//  Update the order accordingly
//
//	RETURN VALUE: 
//
//  Same as OrderSendReliable; 
// NOTES
//  Order will not be updated if an error continues during OrderSendReliableMKT
//  No additional information will be logged since OrderSendReliableMKT would have already
//  logged the error condition
//=============================================================================
int OrderSendReliable2Step(string symbol, int cmd, double volume, double price,
					  int slippage, double stoploss, double takeprofit,
					  string comment, int magic, datetime expiration = 0, 
					  color arrow_color = CLR_NONE) 
{
	OrderReliable_Fname = "OrderSendReliable2Step";
	OrderReliablePrint(" attempted " + OrderReliable_CommandString(cmd) + " " + volume + 
						" lots @" + price + " sl:" + stoploss + " tp:" + takeprofit); 

   int mkt_ticket = OrderSendReliable(symbol,cmd,volume,price,slippage,0,0,comment,magic,expiration,arrow_color);
   if (mkt_ticket > 0 && (stoploss!=0 || takeprofit!=0))
   {   
      OrderSelect(mkt_ticket,SELECT_BY_TICKET);
      bool b_modify = OrderModifyReliable(mkt_ticket,OrderOpenPrice(),stoploss,takeprofit,0,arrow_color);
   }
   return (mkt_ticket);
}


//=============================================================================
//							 OrderModifyReliable()
//
//  This is intended to be a drop-in replacement for OrderModify() which, 
//  one hopes, is more resistant to various forms of errors prevalent 
//  with MetaTrader.
//			  
//  RETURN VALUE: 
//
//       TRUE if successful, FALSE otherwise
//
//
//  FEATURES:
//
//     * Re-trying under some error conditions, sleeping a random 
//       time defined by an exponential probability distribution.
//
//     * Displays various error messages on the log for debugging.
//
//
//  Matt Kennel, 	2006-05-28
//
//=============================================================================
bool OrderModifyReliable(int ticket, double price, double stoploss, 
						 double takeprofit, datetime expiration, 
						 color arrow_color = CLR_NONE) 
{
	OrderReliable_Fname = "OrderModifyReliable";

	OrderReliablePrint(" attempted modify of #" + ticket + " price:" + price + 
						" sl:" + stoploss + " tp:" + takeprofit); 

	if (!IsConnected()) 
	{
		OrderReliablePrint("error: IsConnected() == false");
		_OR_err = ERR_NO_CONNECTION; 
		return(false);
	}
	
	if (IsStopped()) 
	{
		OrderReliablePrint("error: IsStopped() == true");
		return(false);
	}
	
	int cnt = 0;
	while(!IsTradeAllowed() && cnt < retry_attempts) 
	{
		OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
		cnt++;
	}
	if (!IsTradeAllowed()) 
	{
		if (ErrorLevel > 1)
			OrderReliablePrint("error: no operation possible because IsTradeAllowed()==false, even after retries.");
		_OR_err = ERR_TRADE_CONTEXT_BUSY; 
		return(false);  
	}


	
	if (false) {
		 // This section is 'nulled out', because
		 // it would have to involve an 'OrderSelect()' to obtain
		 // the symbol string, and that would change the global context of the
		 // existing OrderSelect, and hence would not be a drop-in replacement
		 // for OrderModify().
		 //
		 // See OrderModifyReliableSymbol() where the user passes in the Symbol 
		 // manually.
		 
		 OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
		 string symbol = OrderSymbol();
		 int digits = MarketInfo(symbol,MODE_DIGITS);
		 if (digits > 0) {
			 price = NormalizeDouble(price,digits);
			 stoploss = NormalizeDouble(stoploss,digits);
			 takeprofit = NormalizeDouble(takeprofit,digits); 
		 }
		 if (stoploss != 0) OrderReliable_EnsureValidStop(symbol,price,stoploss); 
	}



	int err = GetLastError(); // so we clear the global variable.  
	err = 0; 
	_OR_err = 0; 
	bool exit_loop = false;
	cnt = 0;
	bool result = false;
	
	while (!exit_loop) 
	{
		if (IsTradeAllowed()) 
		{
			result = OrderModify(ticket, price, stoploss, 
								 takeprofit, expiration, arrow_color);
			err = GetLastError();
			_OR_err = err; 
		} 
		else 
			cnt++;

		if (result == true) 
			exit_loop = true;

		switch (err) 
		{
			case ERR_NO_ERROR:
				exit_loop = true;
				break;
				
			case ERR_NO_RESULT:
				// modification without changing a parameter. 
				// if you get this then you may want to change the code.
				exit_loop = true;
				break;
				
			case ERR_SERVER_BUSY:
			case ERR_NO_CONNECTION:
			case ERR_INVALID_PRICE:
			case ERR_OFF_QUOTES:
			case ERR_BROKER_BUSY:
			case ERR_TRADE_CONTEXT_BUSY: 
			case ERR_TRADE_TIMEOUT:		// for modify this is a retryable error, I hope. 
				cnt++; 	// a retryable error
				break;
				
			case ERR_PRICE_CHANGED:
			case ERR_REQUOTE:
				RefreshRates();
				continue; 	// we can apparently retry immediately according to MT docs.
				
			default:
				// an apparently serious, unretryable error.
				exit_loop = true;
				break; 
				
		}  // end switch 

		if (cnt > retry_attempts) 
			exit_loop = true; 
			
		if (!exit_loop) 
		{
			OrderReliablePrint("retryable error (" + cnt + "/" + retry_attempts + 
								"): "  +  OrderReliableErrTxt(err)); 
			OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
			RefreshRates(); 
		}
		
		if (exit_loop) 
		{
			if ((err != ERR_NO_ERROR) && (err != ERR_NO_RESULT)) 
				OrderReliablePrint("non-retryable error: "  + OrderReliableErrTxt(err)); 

			if (cnt > retry_attempts) 
				OrderReliablePrint("retry attempts maxed at " + retry_attempts); 
		}
	}  
	
	// we have now exited from loop. 
	if ((result == true) || (err == ERR_NO_ERROR)) 
	{
		OrderReliablePrint("apparently successful modification order, updated trade details follow.");
		OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES); 
		OrderPrint(); 
		return(true); // SUCCESS! 
	} 
	
	if (err == ERR_NO_RESULT) 
	{
		OrderReliablePrint("Server reported modify order did not actually change parameters.");
		OrderReliablePrint("redundant modification: "  + ticket + " " + symbol + 
							"@" + price + " tp@" + takeprofit + " sl@" + stoploss); 
		OrderReliablePrint("Suggest modifying code logic to avoid."); 
		return(true);
	}
	
	OrderReliablePrint("failed to execute modify after " + cnt + " retries");
	OrderReliablePrint("failed modification: "  + ticket + " " + symbol + 
						"@" + price + " tp@" + takeprofit + " sl@" + stoploss); 
	OrderReliablePrint("last error: " + OrderReliableErrTxt(err)); 
	
	return(false);  
}

//=============================================================================
//                         OrderModifyReliableSymbol()
//
//  This has the same calling sequence as OrderModify() except that the 
//  user must provide the symbol.
//
//  This function will then be able to ensure proper normalization and 
//  stop levels.
//
//=============================================================================
/*
bool OrderModifyReliableSymbol(string symbol, int ticket, double price, 
							   double stoploss, double takeprofit, 
							   datetime expiration, color arrow_color = CLR_NONE) 
{
	int digits = MarketInfo(symbol, MODE_DIGITS);
	
	if (digits > 0) 
	{
		price = NormalizeDouble(price, digits);
		stoploss = NormalizeDouble(stoploss, digits);
		takeprofit = NormalizeDouble(takeprofit, digits); 
	}
	
	if (stoploss != 0) 
		OrderReliable_EnsureValidStop(symbol, price, stoploss); 
		
	return(OrderModifyReliable(ticket, price, stoploss, 
								takeprofit, expiration, arrow_color)); 
	
}
*/ 
//=============================================================================
//                            OrderCloseReliable()
//
//  This is intended to be a drop-in replacement for OrderClose() which, 
//  one hopes, is more resistant to various forms of errors prevalent 
//  with MetaTrader.
//			  
//  RETURN VALUE: 
//
//       TRUE if successful, FALSE otherwise
//
//
//  FEATURES:
//
//     * Re-trying under some error conditions, sleeping a random 
//       time defined by an exponential probability distribution.
//
//     * Displays various error messages on the log for debugging.
//
//
//  Derk Wehler, ashwoods155@yahoo.com | 2006-07-19
//
//=============================================================================
bool OrderCloseReliable(int ticket, double lots, double price, 
						int slippage, color arrow_color = CLR_NONE) 
{
	int nOrderType;
	string strSymbol;
	OrderReliable_Fname = "OrderCloseReliable";
	
	OrderReliablePrint(" attempted close of #" + ticket + " price:" + price + 
						" lots:" + lots + " slippage:" + slippage); 

	// collect details of order so that we can use GetMarketInfo later if needed
	if (!OrderSelect(ticket,SELECT_BY_TICKET))
	{
		_OR_err = GetLastError();		
		OrderReliablePrint("error: " + ErrorDescription(_OR_err));
		return(false);
	}
	else
	{
		nOrderType = OrderType();
		strSymbol = Symbol();
	}

	if (nOrderType != OP_BUY && nOrderType != OP_SELL)
	{
		_OR_err = ERR_INVALID_TICKET;
		OrderReliablePrint("error: trying to close ticket #" + ticket + ", which is " + OrderReliable_CommandString(nOrderType) + ", not OP_BUY or OP_SELL");
		return(false);
	}

	if (!IsConnected()) 
	{
		OrderReliablePrint("error: IsConnected() == false");
		_OR_err = ERR_NO_CONNECTION; 
		return(false);
	}
	
	if (IsStopped()) 
	{
		OrderReliablePrint("error: IsStopped() == true");
		return(false);
	}

	
	int cnt = 0;
/*	
	Commented out by Paul Hampton-Smith due to a bug in MT4 that sometimes incorrectly returns IsTradeAllowed() = false
	while(!IsTradeAllowed() && cnt < retry_attempts) 
	{
		OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
		cnt++;
	}
	if (!IsTradeAllowed()) 
	{
		if (ErrorLevel > 1)
			OrderReliablePrint("error: no operation possible because IsTradeAllowed()==false, even after retries.");
		_OR_err = ERR_TRADE_CONTEXT_BUSY; 
		return(false);  
	}
*/

	int err = GetLastError(); // so we clear the global variable.  
	err = 0; 
	_OR_err = 0; 
	bool exit_loop = false;
	cnt = 0;
	bool result = false;
	
	while (!exit_loop) 
	{
		if (IsTradeAllowed()) 
		{
			result = OrderClose(ticket, lots, price, slippage, arrow_color);
			err = GetLastError();
			_OR_err = err; 
		} 
		else 
			cnt++;

		if (result == true) 
			exit_loop = true;

		switch (err) 
		{
			case ERR_NO_ERROR:
				exit_loop = true;
				break;
				
			case ERR_SERVER_BUSY:
			case ERR_NO_CONNECTION:
			case ERR_INVALID_PRICE:
			case ERR_OFF_QUOTES:
			case ERR_BROKER_BUSY:
			case ERR_TRADE_CONTEXT_BUSY: 
			case ERR_TRADE_TIMEOUT:		// for modify this is a retryable error, I hope. 
				cnt++; 	// a retryable error
				break;
				
			case ERR_PRICE_CHANGED:
			case ERR_REQUOTE:
				continue; 	// we can apparently retry immediately according to MT docs.
				
			default:
				// an apparently serious, unretryable error.
				exit_loop = true;
				break; 
				
		}  // end switch 

		if (cnt > retry_attempts) 
			exit_loop = true; 
			
		if (!exit_loop) 
		{
			OrderReliablePrint("retryable error (" + cnt + "/" + retry_attempts + 
								"): "  +  OrderReliableErrTxt(err)); 
			OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
			
			// Added by Paul Hampton-Smith to ensure that price is updated for each retry
			if (nOrderType == OP_BUY)  
				price = NormalizeDouble(MarketInfo(strSymbol, MODE_BID), MarketInfo(strSymbol, MODE_DIGITS));
			if (nOrderType == OP_SELL) 
				price = NormalizeDouble(MarketInfo(strSymbol, MODE_ASK), MarketInfo(strSymbol, MODE_DIGITS));
		}
		
		if (exit_loop) 
		{
			if ((err != ERR_NO_ERROR) && (err != ERR_NO_RESULT)) 
				OrderReliablePrint("non-retryable error: " + OrderReliableErrTxt(err)); 

			if (cnt > retry_attempts) 
				OrderReliablePrint("retry attempts maxed at " + retry_attempts); 
		}
	}  
	
	// we have now exited from loop. 
	if ((result == true) || (err == ERR_NO_ERROR)) 
	{
		OrderReliablePrint("apparently successful close order.");
		return(true); // SUCCESS! 
	} 
	
	OrderReliablePrint("failed to execute close after " + cnt + " retries");
	OrderReliablePrint("failed close: Ticket #" + ticket + ", Price: " + 
						price + ", Slippage: " + slippage); 
	OrderReliablePrint("last error: " + OrderReliableErrTxt(err)); 
	
	return(false);  
}
 
 
//=============================================================================
//                            OrderDeleteReliable()
//
//  This is intended to be a drop-in replacement for OrderDelete() which, 
//  one hopes, is more resistant to various forms of errors prevalent 
//  with MetaTrader.
//			  
//  RETURN VALUE: 
//
//       TRUE if successful, FALSE otherwise
//
//
//  FEATURES:
//
//     * Re-trying under some error conditions, sleeping a random 
//       time defined by an exponential probability distribution.
//
//     * Displays various error messages on the log for debugging.
//
//
//  Derk Wehler, ashwoods155@yahoo.com | 2006-12-21
//
//=============================================================================
/*
bool OrderDeleteReliable(int ticket) 
{
	int nOrderType;
	string strSymbol;
	OrderReliable_Fname = "OrderDeleteReliable";
	
	OrderReliablePrint(" attempted deletion of pending order, #" + ticket); 

	// collect details of order so that we can use GetMarketInfo later if needed
	if (!OrderSelect(ticket, SELECT_BY_TICKET))
	{
		_OR_err = GetLastError();		
		OrderReliablePrint("error: " + ErrorDescription(_OR_err));
		return(false);
	}
	else
	{
		nOrderType = OrderType();
		strSymbol = Symbol();
	}

	if (nOrderType == OP_BUY || nOrderType == OP_SELL)
	{
		_OR_err = ERR_INVALID_TICKET;
		OrderReliablePrint("error: trying to close ticket #" + ticket + 
							", which is " + OrderReliable_CommandString(nOrderType) + 
							", not OP_BUYSTOP, OP_SELLSTOP, OP_BUYLIMIT, or OP_SELLLIMIT");
		return(false);
	}

	if (!IsConnected()) 
	{
		OrderReliablePrint("error: IsConnected() == false");
		_OR_err = ERR_NO_CONNECTION; 
		return(false);
	}
	
	if (IsStopped()) 
	{
		OrderReliablePrint("error: IsStopped() == true");
		return(false);
	}

	
	int cnt = 0;


	int err = GetLastError(); // so we clear the global variable.  
	err = 0; 
	_OR_err = 0; 
	bool exit_loop = false;
	cnt = 0;
	bool result = false;
	
	while (!exit_loop) 
	{
		if (IsTradeAllowed()) 
		{
			result = OrderDelete(ticket);
			err = GetLastError();
			_OR_err = err; 
		} 
		else 
			cnt++;

		if (result == true) 
			exit_loop = true;

		switch (err) 
		{
			case ERR_NO_ERROR:
				exit_loop = true;
				break;
				
			case ERR_SERVER_BUSY:
			case ERR_NO_CONNECTION:
			case ERR_INVALID_PRICE:
			case ERR_OFF_QUOTES:
			case ERR_BROKER_BUSY:
			case ERR_TRADE_CONTEXT_BUSY: 
			case ERR_TRADE_TIMEOUT:		// for modify this is a retryable error, I hope. 
				cnt++; 	// a retryable error
				break;
				
			case ERR_PRICE_CHANGED:
			case ERR_REQUOTE:
				continue; 	// we can apparently retry immediately according to MT docs.
				
			default:
				// an apparently serious, unretryable error.
				exit_loop = true;
				break; 
				
		}  // end switch 

		if (cnt > retry_attempts) 
			exit_loop = true; 
			
		if (!exit_loop) 
		{
			OrderReliablePrint("retryable error (" + cnt + "/" + retry_attempts + 
								"): "  +  OrderReliableErrTxt(err)); 
			OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
		}
		
		if (exit_loop) 
		{
			if ((err != ERR_NO_ERROR) && (err != ERR_NO_RESULT)) 
				OrderReliablePrint("non-retryable error: " + OrderReliableErrTxt(err)); 

			if (cnt > retry_attempts) 
				OrderReliablePrint("retry attempts maxed at " + retry_attempts); 
		}
	}  
	
	// we have now exited from loop. 
	if ((result == true) || (err == ERR_NO_ERROR)) 
	{
		OrderReliablePrint("apparently successful deletion order.");
		return(true); // SUCCESS! 
	} 
	
	OrderReliablePrint("failed to execute delete after " + cnt + " retries");
	OrderReliablePrint("failed deletion: Ticket #" + ticket); 
	OrderReliablePrint("last error: " + OrderReliableErrTxt(err)); 
	
	return(false);  
}
 
*/ 

//=============================================================================
//=============================================================================
//								Utility Functions
//=============================================================================
//=============================================================================
/*

int OrderReliableLastErr() 
{
	return (_OR_err); 
}

*/

string OrderReliableErrTxt(int err) 
{
	return ("" + err + ":" + ErrorDescription(err)); 
}


// Defaut level is 3
// Use level = 1 to Print all but "Retry" messages
// Use level = 0 to Print nothing

/*
void OrderReliableSetErrorLevel(int level) 
{
	ErrorLevel = level;
}
*/

void OrderReliablePrint(string s) 
{
	// Print to log prepended with stuff;
	if (!(IsTesting() || IsOptimization())) 
	{
		if (ErrorLevel > 0)
			Print(OrderReliable_Fname + " " + OrderReliableVersion + ":" + s);
	}
}


string OrderReliable_CommandString(int cmd) 
{
	if (cmd == OP_BUY) 
		return("OP_BUY");

	if (cmd == OP_SELL) 
		return("OP_SELL");

	if (cmd == OP_BUYSTOP) 
		return("OP_BUYSTOP");

	if (cmd == OP_SELLSTOP) 
		return("OP_SELLSTOP");

	if (cmd == OP_BUYLIMIT) 
		return("OP_BUYLIMIT");

	if (cmd == OP_SELLLIMIT) 
		return("OP_SELLLIMIT");

	return("(CMD==" + cmd + ")"); 
}


//=============================================================================
//                        OrderReliable_EnsureValidStop()
//
//  Adjust stop loss so that it is legal.
//
//  Matt Kennel 
//
//=============================================================================
void OrderReliable_EnsureValidStop(string symbol, double price, double& sl) 
{
	// Return if no S/L
	if (sl == 0) 
		return;
	
	double servers_min_stop = MarketInfo(symbol, MODE_STOPLEVEL) * MarketInfo(symbol, MODE_POINT); 
	
	if (MathAbs(price - sl) <= servers_min_stop) 
	{
		// we have to adjust the stop.
		if (price > sl)
			sl = price - servers_min_stop;	// we are long
			
		else if (price < sl)
			sl = price + servers_min_stop;	// we are short
			
		else
			OrderReliablePrint("EnsureValidStop: error, passed in price == sl, cannot adjust"); 
			
		sl = NormalizeDouble(sl, MarketInfo(symbol, MODE_DIGITS)); 
	}
}


//=============================================================================
//                      OrderReliable_SleepRandomTime()
//
//  This sleeps a random amount of time defined by an exponential 
//  probability distribution. The mean time, in Seconds is given 
//  in 'mean_time'.
//
//  This is the back-off strategy used by Ethernet.  This will 
//  quantize in tenths of seconds, so don't call this with a too 
//  small a number.  This returns immediately if we are backtesting
//  and does not sleep.
//
//  Matt Kennel mbkennelfx@gmail.com.
//
//=============================================================================
void OrderReliable_SleepRandomTime(double mean_time, double max_time) 
{
	if (IsTesting()) 
		return; 	// return immediately if backtesting.

	double tenths = MathCeil(mean_time / 0.1);
	if (tenths <= 0) 
		return; 
	 
	int maxtenths = MathRound(max_time/0.1); 
	double p = 1.0 - 1.0 / tenths; 
	  
	Sleep(100); 	// one tenth of a second PREVIOUS VERSIONS WERE STUPID HERE. 
	
	for(int i=0; i < maxtenths; i++)  
	{
		if (MathRand() > p*32768) 
			break; 
			
		// MathRand() returns in 0..32767
		Sleep(100); 
	}
}  
 



